----------------------------------------------------------------------------------
-- Company:
-- Engineer: IGNACIO SERNA ESCOBEDO & SANTIAGO VIVES MERINO
-- 
-- Create Date: 09.01.2020
-- Design Name:
-- Module Name: DISPLAY_REFRESH - BEHAVIORAL
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision: 14.01.2020
-- Additional Comments:
-- 
----------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity DISPLAY_REFRESH is
	generic(
		DISPLAY_REFRESH_N : positive := 7;
		DISPLAY_REFRESH_M : positive := 8
	);
	port(
		DISPLAY_REFRESH_CLOCK : in std_logic;
		DISPLAY_REFRESH_DIGIT_0 : in std_logic_vector(DISPLAY_REFRESH_N-1 downto 0);
		DISPLAY_REFRESH_DIGIT_1 : in std_logic_vector(DISPLAY_REFRESH_N-1 downto 0);
		DISPLAY_REFRESH_DIGIT_2 : in std_logic_vector(DISPLAY_REFRESH_N-1 downto 0);
		DISPLAY_REFRESH_DIGIT_3 : in std_logic_vector(DISPLAY_REFRESH_N-1 downto 0);
		DISPLAY_REFRESH_DIGIT_4 : in std_logic_vector(DISPLAY_REFRESH_N-1 downto 0);
		DISPLAY_REFRESH_DIGIT_5 : in std_logic_vector(DISPLAY_REFRESH_N-1 downto 0);
		DISPLAY_REFRESH_DIGIT_6 : in std_logic_vector(DISPLAY_REFRESH_N-1 downto 0);
		DISPLAY_REFRESH_DIGIT_7 : in std_logic_vector(DISPLAY_REFRESH_N-1 downto 0);
		DISPLAY_REFRESH_DISPLAY_DIGIT : out std_logic_vector(DISPLAY_REFRESH_N-1 downto 0);
		DISPLAY_REFRESH_DISPLAY_SELECTION : out std_logic_vector(DISPLAY_REFRESH_M-1 downto 0)
	);
end entity DISPLAY_REFRESH;

architecture BEHAVIORAL of DISPLAY_REFRESH is
begin
	process(DISPLAY_REFRESH_CLOCK, DISPLAY_REFRESH_DIGIT_0, DISPLAY_REFRESH_DIGIT_1, DISPLAY_REFRESH_DIGIT_2, DISPLAY_REFRESH_DIGIT_3, DISPLAY_REFRESH_DIGIT_4, DISPLAY_REFRESH_DIGIT_5, DISPLAY_REFRESH_DIGIT_6, DISPLAY_REFRESH_DIGIT_7)
		variable V_COUNTER : integer range 0 to DISPLAY_REFRESH_M-1;
	begin
		if(rising_edge(DISPLAY_REFRESH_CLOCK)) then
			if(V_COUNTER = DISPLAY_REFRESH_M-1) then
				V_COUNTER := 0;
			else
				V_COUNTER := V_COUNTER+1;
			end if;
		end if;
		case V_COUNTER is
			when 0 =>	DISPLAY_REFRESH_DISPLAY_SELECTION <= "11111110";
						DISPLAY_REFRESH_DISPLAY_DIGIT <= DISPLAY_REFRESH_DIGIT_0;
			when 1 =>	DISPLAY_REFRESH_DISPLAY_SELECTION <= "11111101";
						DISPLAY_REFRESH_DISPLAY_DIGIT <= DISPLAY_REFRESH_DIGIT_1;
			when 2 =>	DISPLAY_REFRESH_DISPLAY_SELECTION <= "11111011";
						DISPLAY_REFRESH_DISPLAY_DIGIT <= DISPLAY_REFRESH_DIGIT_2;
			when 3 =>	DISPLAY_REFRESH_DISPLAY_SELECTION <= "11110111";
						DISPLAY_REFRESH_DISPLAY_DIGIT <= DISPLAY_REFRESH_DIGIT_3;
			when 4 =>	DISPLAY_REFRESH_DISPLAY_SELECTION <= "11101111";
						DISPLAY_REFRESH_DISPLAY_DIGIT <= DISPLAY_REFRESH_DIGIT_4;
			when 5 =>	DISPLAY_REFRESH_DISPLAY_SELECTION <= "11011111";
						DISPLAY_REFRESH_DISPLAY_DIGIT <= DISPLAY_REFRESH_DIGIT_5;
			when 6 =>	DISPLAY_REFRESH_DISPLAY_SELECTION <= "10111111";
						DISPLAY_REFRESH_DISPLAY_DIGIT <= DISPLAY_REFRESH_DIGIT_6;
			when 7 =>	DISPLAY_REFRESH_DISPLAY_SELECTION <= "01111111";
						DISPLAY_REFRESH_DISPLAY_DIGIT <= DISPLAY_REFRESH_DIGIT_7;
			when others =>	DISPLAY_REFRESH_DISPLAY_SELECTION <= "00000000";
							DISPLAY_REFRESH_DISPLAY_DIGIT <= "0000110";--"E"
		end case;
	end process;
end architecture BEHAVIORAL;